/*
 * Copyright 2009-2010 Nanjing RedOrange ltd (http://www.red-orange.cn)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package redora.client.mvp;

import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.IsWidget;
import com.google.gwt.view.client.HasData;

/**
 * Tabular view widget to display records with data from the database.
 * Redora generates a [Pojo]TableView for each object in your model.
 * You can customize this view by changing the field list before invoking
 * initTable();. Usage in the presenter code:
 * <code>
 * TableView display = clientFactory.getLocator().locateTableView(Pojo.class);
 * display.setPresenter(this);
 * //display.getFields()... do some customizations here
   display.initTable(); //init the table header.
 * </code>
 * @author Nanjing RedOrange (www.red-orange.cn)
 */
public interface TableView extends IsWidget, FieldView {

    public interface Presenter {
    }

    /**
     * Sets up the ScrollTable by adding the fields (from display.getFields()).
    */
    void initTable();
    void setPresenter(Presenter presenter);
    HasClickHandlers addButton();
    HasData getData();
    HasWidgets panel();
}
